/* $Id: generic.c,v 1.7 1998/11/24 18:33:31 marcus Exp $
******************************************************************************

   Generic frambuffer support

   Copyright (C) 1995-97 Andreas Beck	[becka@ggi-project.org]
   Copyright (C) 1995-97 Steffen Seeger	[seeger@ggi-project.org]
   Copyright (C) 1997    Jason McMullan	[jmcc@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#define	MAINTAINER	"Jason McMullan, [jmcc@ggi-project.org]"
#define	DRIVER_VERSION	"0.01"

#include <kgi/module.h>
#include <kgi/kgi_commands.h>

#include "suggest.inc"

/*
**	KGI module interface
*/

int kgim_accel_init(struct kgi_card *card, struct kgi_display *dpy)
{
	/* !!! We should really do something here !!! */
	TRACE(printk("generic linear framebuffer accel driver loaded\n"));
	return EOK;
}

void kgim_accel_done(struct kgi_display *dpy)
{
	TRACE(printk("generic linear framebuffer accel driver removed\n"));
}

int kgim_accel_check_mode(struct kgi_display *dpy, struct kgi_mode *mode,
			  enum kgi_tm_cmd *cmd)
{
	/* !!! Should we check for accel-friendly dimensions here ??? */
	return EOK;

}

void kgim_accel_set_mode(struct kgi_display *dpy, struct kgi_mode *mode)
{
	/* !!! We should set up the accel here !!! */
	return;
}


int kgim_accel_command(struct kgi_graphic *gr, kgi_uint cmd, kgi_uint arg)
{ 
	kgi_suggest *sugg;
	const char *name;

	switch (cmd) 
	{

	case ACCEL_GETSUGGEST:
		sugg=(kgi_suggest *)(gr->io_buf);
		gr->io_res=gr->io_buf;

		if (sugg->id<0 || sugg->id > 1)
			return -E(ACCEL, BOGUS);

		if (sugg->id==1) { /* Generic RAMDAC support */

			name = sugg_ramdac[gr->dev.mode.graphtype];
			strcpy(sugg->name, name);
			sugg->args[0] = 0;
			sugg->id = 0;
			return EOK;
		}
		name=sugg_default[gr->dev.mode.graphtype];
		strcpy(sugg->name,name);
		sugg->args[0] = 0;
		sugg->id = 1;	/* Next is RAMDAC.. */
		return EOK;

	default:
		break;
	}
			
	return -E(ACCEL, NOSUP_ALWAYS_MMAP);
}
